
// last found map if known
string knownmap;

// generated by my server after auth and used to check all messages
string sessionToken = "";

enum Status {
    NoConnection,
    NotStreamer,
    Streamer
}
Status status = Status::NoConnection;

const uint64 retryConnectionTime = 600000;

void client_auth() {
    status = Status::NoConnection;
    status = preAuth();
    if (status == Status::NotStreamer) {
        return;
    } else if (status == Status::NoConnection) {
        sleep(retryConnectionTime);
        return;
    }
    status = authWithServer(); // full auth with Openplanet servers
    if (status == Status::NotStreamer) {
        // this shouldn't happen unless the plugin is modified to fake the account as a streamer
        print('failed to auth but login is known streamer');
        return;
    } else if (status == Status::NoConnection) {
        sleep(retryConnectionTime);
        return;
    }
}

void client_main() {
    while (true) {
        string currentmap = getMapUid();
        if (currentmap != knownmap) {
            knownmap = currentmap;
            if (currentmap != "") {
                // trace('sending info to server');
                Json::Value@ info = getInfo();
                if (!sendToServer(info)) {
                    // either no connection or invalid login but will fully reset
                    // so that when server is back it should return to normal
                    status = Status::NoConnection;
                    return;
                }
            }
        }
        sleep(100);
    }
}

void Main() {
    while (GetApp() is null) {yield();}
    // if connection fails, will retry auth
    do {
        client_auth();
        if (status == Status::Streamer) {
            yield();
            client_main();
        }
    } while (status == Status::NoConnection);
}
