
const string baseurl = "http://areyeses.ddns.net:3000";
const string mapurl = baseurl + "/map";
const string preauthurl = baseurl + "/preauth";
const string authurl = baseurl + "/auth";

// check that the login is valid with my server before verifying user with Openplanet
Status preAuth() {
    CGameCtnApp@ app = GetApp();
    Json::Value@ body = Json::Object();
    body['login'] = app.LocalPlayerInfo.Login;
    Net::HttpRequest@ req = Net::HttpPost(preauthurl, Json::Write(body), 'application/json');
    req.Start();
    while (!req.Finished()) {yield();}
    if (req.ResponseCode() == 403) {
        UI::ShowNotification(Meta::ExecutingPlugin().Name, 'You are not registed as a valid streamer');
        print('Invalid login');
        return Status::NotStreamer;
    } else if (req.ResponseCode() == 0) {
        UI::ShowNotification(Meta::ExecutingPlugin().Name, 'Failed to connect to server (retry in ' + int(retryConnectionTime/60000) + 'min)');
        print('Failed to connect to server');
        return Status::NoConnection;
    }
    return Status::Streamer;
}

// use Openplanet's auth system to verify the user is who they say they are, and recieve a session token
Status authWithServer() {
    CGameCtnApp@ app = GetApp();
    Json::Value@ body = Json::Object();
    Auth::PluginAuthTask@ task = Auth::GetToken();
    while (!task.Finished()) {yield();}
    body['authtoken'] = task.Token();
    body['login'] = app.LocalPlayerInfo.Login;
    // body['id'] = app.LocalPlayerInfo.WebServicesUserId;
    Net::HttpRequest@ req = Net::HttpPost(authurl, Json::Write(body), 'application/json');
    req.Start();
    while (!req.Finished()) {yield();}
    if (req.ResponseCode() == 403) {
        print('Invalid login (but didn\'t fail on preauth YEK)');
        return Status::NotStreamer;
    } else if (req.ResponseCode() == 0) {
        UI::ShowNotification(Meta::ExecutingPlugin().Name, 'Failed to connect to server (retry in 10min)');
        print('Failed to connect to server');
        return Status::NoConnection;
    }
    if (req.ResponseCode() != 200 || req.String().Length == 0) {
        UI::ShowNotification(Meta::ExecutingPlugin().Name, "Invalid repsonse from server");
        print("" + req.ResponseCode() + ', ' + req.String());
        return Status::NotStreamer;
    }
    Json::Value@ response = Json::Parse(req.String());
    sessionToken = response['sessiontoken'];
    trace('authenticated with server');
    UI::ShowNotification(Meta::ExecutingPlugin().Name, "Authenticated with server. Your played maps will be shared");
    return Status::Streamer;
}

// send each map to the server along with the valid session token
bool sendToServer(Json::Value@ mapdata) {
    Net::HttpRequest@ req = Net::HttpPost(mapurl, Json::Write(mapdata), 'application/json');
    while (!req.Finished()) {yield();}
    if (req.ResponseCode() == 403) {
        // maybe something has happened to the server since we started TM, so retry auth once
        print('invalid token despite working earlier');
        return false;
    } else if (req.ResponseCode() == 0) {
        print('Failed to send to server');
        return false;
    }
    return true;
}
